.286
code segment
     assume cs:code
     org 100h
@1:  jmp @2

     ZoomIn       EQU 128
     ZoomOut      EQU 16
     WindowX      EQU 0
     WindowY      EQU 0
     WindowWidth  EQU 320
     WindowHeight EQU 200

     data label byte
     include data.inc

     ydiv db ZoomIn dup(0)
     c db 0
     o db 0
     e db 1
     l dw 0

@2:  mov ax, 13h
     int 10h
     push 0A000h
     pop es

     call setcolor
     call setpal
;     call fillscreen
     mov cx, ZoomIn

@9:  push cx
     call zoomall
     call check_o
     pop cx
     dec cx
     mov ah, 1
     int 16h
     jnz ex
     cmp cx, ZoomOut
     jne @9
@W:  push cx
     call zoomall
     call check_o
     pop cx
     inc cx
     mov ah, 1
     int 16h
     jnz ex
     cmp cx, ZoomIn
     jne @W
     inc e
     cmp e, 7
     jne i
     mov e, 1
i:   pusha
     call setcolor
     call setpal
     popa
     jmp @9

ex:  mov c, 63
c2:  call fadepal
     call vertret
     dec c
     jnz c2

     xor ax, ax
     int 16h
     mov ax, 3
     int 10h
     mov ax, 4C00h
     int 21h

zoomall proc near
     cli
     xor dx, dx
     mov ax, cx
     mov bx, 100
     mul bx
     shr ax, 6
     mul o
     div bx
     mov l, ax
     call fillarrays
     mov di, WindowY*320+WindowX
     mov dx, cx
     mov cx, WindowHeight
     mov bp, l
@8:  push cx
     push dx
     cmp bp, dx
     jne @C
     xor bp, bp
@C:  xor ah, ah
     mov al, ydiv[bp]
     mov si, offset data
     add si, 1024
     shl ax, 6
     add si, ax
     mov cx, 64
     push bp
     mov cx, WindowWidth
     mov bp, l
     xor ah, ah
     mov al, o
     mov bx, ax
@D:  push si
     cmp bp, dx
     jne @S
     xor bp, bp
@S:  xor ah, ah
     mov al, ydiv[bp]
     add si, ax
     mov al, ds:[si]
     cmp al, 'M'
     jne @j
     mov al, bl
     add al, 191
     stosb
     jmp @y
@j:  movsb
@y:  inc bp
     inc bx
     cmp bl, 64
     jne @t
     xor bx, bx
@t:  pop si
     loop @D
     pop bp
     add di, 320-WindowWidth
     pop dx
     pop cx
     inc bp
     loop @8
     call VertRet
     ret
     sti
zoomall endp

check_o proc near
     add o, 2
     cmp o, 64
     jne @l
     mov o, 0
@l:  ret
check_o endp

fillscreen proc near
     mov cx, 200
@v:  push cx
     mov cx, 5
@g:  push cx
     mov cx, 64
@e:  mov al, cl
     add al, 191
     stosb
     loop @e
     pop cx
     loop @g
     pop cx
     loop @v
     ret
fillscreen endp

setcolor proc near
     mov cx, 31
     mov bp, 255
     shl bp, 2
     xor al, al
@o:  call test_e
     sub bp, 4
     add al, 8
     loop @o
     mov cx, 31
@p:  call test_e
     sub bp, 4
     sub al, 8
     loop @p
     ret
setcolor endp

test_e proc near
     mov bl, 0
     test e, 1
     jz n1
     mov bl, al
n1:  mov data[bp], bl
     mov bl, 0
     test e, 2
     jz n2
     mov bl, al
n2:  mov data[bp+1], bl
     mov bl, 0
     test e, 4
     jz n3
     mov bl, al
n3:  mov data[bp+2], bl
     ret
test_e endp

fillarrays proc near
     push cx
     mov bx, cx
@7:  xor dx, dx
     mov ax, 64512
     div bx
     mul cx
     shr ax, 10
     mov bp, cx
     mov ydiv[bp], al
     loop @7
     pop cx
     ret
fillarrays endp

setpal proc near
     mov cx, 0FFh
@6:  mov  ax, cx
     mov  bx, 4
     mul  bx
     mov  bp, ax
     mov  dx, 03C8h
     mov  al, cl
     out  dx, al
     inc  dx
     mov  al, data[bp+2]
     shr  al, 2
     out  dx, al
     mov  al, data[bp+1]
     shr  al, 2
     out  dx, al
     mov  al, data[bp]
     shr  al, 2
     out  dx, al
     loop @6
     ret
setpal endp

VertRet proc near
     push dx
     mov  dx, 03DAh
@4:  in   al, dx
     test al, 8
     jz   @4
@5:  in   al, dx
     test al, 8
     jnz  @5
     pop dx
     ret
VertRet endp

fadepal proc near
     mov cx, 0FFh
@@6: mov ax, cx
     mov bx, 4
     mul bx
     mov bp, ax
     mov dx, 03C8h
     mov al, cl
     out dx, al
     inc dx
     mov al, data[bp+2]
     shr al, 2
     call fade
     out dx, al
     mov al, data[bp+1]
     shr al, 2
     call fade
     out dx, al
     mov al, data[bp]
     shr al, 2
     call fade
     out dx, al
     loop @@6
     ret
fadepal endp

fade proc near
     push dx
     xor dx, dx
     mov bl, 100
     mul bl
     mov bl, 63
     div bl
     mul c
     mov bl, 100
     div bl
     pop dx
     ret
fade endp

code ends
     end @1